#ifndef AlphaFeld_H
#define AlphaFeld_H

#include "Zeichnung.h"

namespace Framework
{
    class Bild; // Bild.h
    class AlphaFeld; // Aus dieser Datei

    // Eine Zeichnung des 2D GUI Frameworks, die einen Farbbergang zu einem Rechteck darstellt
    class AlphaFeld : public Zeichnung
    {
    private:
        int strke;
        int farbe;
        int ref;

    public:
        // Konstruktor 
        __declspec( dllexport ) AlphaFeld();
        // Setzt die Strke des bergangs. Dies ist der Wert um den der Alpha Wert der Farbe fr jeden Pixel nach innen abnimmt
        //  st: Die Strke
        __declspec( dllexport ) void setStrke( int st );
        // Setzt die Farbe des Alpha Feldes
        //  f: Die Farbe im A8R8G8B8 Format
        __declspec( dllexport ) void setFarbe( int f );
        // Zeichnet die Zeihnung in ein bestimmtes Bild
        //  zRObj: Das Bild, in das gezeichnet werden soll
        __declspec( dllexport ) void render( Bild &zRObj ) override;
        // Gibt die Strke des Alpha Feldes zurck
        __declspec( dllexport ) int getStrke() const;
        // gibt die Farbe des Alpha Feldes im A8R8G8B8 Format zurck
        __declspec( dllexport ) int getFarbe() const;
        // Kopiert das Alpha Feld, so dass es ohne auswirkungen auf das Original verwendet werden kann
        __declspec( dllexport ) Zeichnung *dublizieren() const override;
        // Erhht den Reference Counting Zhler.
        //  return: this.
        __declspec( dllexport ) AlphaFeld *getThis();
        // Verringert den Reference Counting Zhler. Wenn der Zhler 0 erreicht, wird das Objekt automatisch gelscht.
        //  return: 0.
        __declspec( dllexport ) AlphaFeld *release();
    };
}

#endif