#pragma once

#include "Model3D.h"

namespace Framework
{
    class Bild; // Bild.h

    // Ein 3D Modell, das zur Darstellung einer Textur im dreidimensionalen Raum verwendet werden kann
    class TexturModel : public Model3D
    {
    public:
        // Konstruktor
        __declspec( dllexport ) TexturModel();
        // Setzt die Textur die angezeigt werden soll
        //  textur: Die Textur als Bild
        __declspec( dllexport ) void setTextur( Bild *textur );
        // Setzt die Textur die angezeigt werden soll 
        //  id: Die id der Textur. Sie muss im Textur Register des Frameworks registriert sein
        __declspec( dllexport ) void setTextur( int id );
        // Setzt die Gre, in der Die Textur angezeigt wird
        //  gr: Ein Vektor, der fr x und y die breite und hhe beinhaltet
        __declspec( dllexport ) void setGre( Vec2< float > gr );
        // Setzt die Gre, in der die Textur angezeigt wird
        //  b: Die Breite, in der die Textur angezeigt wird
        //  h: Die Hhe, in der die Textur angezeigt wird
        __declspec( dllexport ) void setGre( float b, float h );
        // Verringert den Reference Counting Zhler. Wenn der Zhler 0 erreicht, wird das Zeichnung automatisch gelscht.
        //  return: 0.
        __declspec( dllexport ) Model3D *release() override;
    };
}